// Code generated by cmd/generate/main.go; DO NOT EDIT.

package service

import (
	"code.pfad.fr/gohmekit/hapip"
	"code.pfad.fr/gohmekit/hapip/characteristic"
)

const AccessoryInformation_Type = "3E"

// AccessoryInformation represents a Accessory Information service (3E)
// Required characteristics:
//   - identify: Identify (14)
//   - manufacturer: Manufacturer (20)
//   - model: Model (21)
//   - name: Name (23)
//   - serialNumber: Serial Number (30)
//   - firmwareRevision: Firmware Revision (52)
//
// Optional characteristics:
//   - Hardware Revision (53)
//   - Accessory Flags (A6)
//
// UUID: 0000003E-0000-1000-8000-0026BB765291
func AccessoryInformation(identify hapip.Characteristic, manufacturer hapip.Characteristic, model hapip.Characteristic, name hapip.Characteristic, serialNumber hapip.Characteristic, firmwareRevision hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{identify, manufacturer, model, name, serialNumber, firmwareRevision}
	return characteristic.Service{
		Typ:            AccessoryInformation_Type,
		Characteristic: append(chars, optional...),
	}
}

const AirPurifier_Type = "BB"

// AirPurifier represents a Air Purifier service (BB)
// Required characteristics:
//   - active: Active (B0)
//   - currentAirPurifierState: Current Air Purifier State (A9)
//   - targetAirPurifierState: Target Air Purifier State (A8)
//
// Optional characteristics:
//   - Lock Physical Controls (A7)
//   - Name (23)
//   - Swing Mode (B6)
//   - Rotation Speed (29)
//
// UUID: 000000BB-0000-1000-8000-0026BB765291
func AirPurifier(active hapip.Characteristic, currentAirPurifierState hapip.Characteristic, targetAirPurifierState hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{active, currentAirPurifierState, targetAirPurifierState}
	return characteristic.Service{
		Typ:            AirPurifier_Type,
		Characteristic: append(chars, optional...),
	}
}

const AirQualitySensor_Type = "8D"

// AirQualitySensor represents a Air Quality Sensor service (8D)
// Required characteristics:
//   - airQuality: Air Quality (95)
//
// Optional characteristics:
//   - Status Active (75)
//   - Status Fault (77)
//   - Status Tampered (7A)
//   - Status Low Battery (79)
//   - Name (23)
//   - Ozone Density (C3)
//   - Nitrogen Dioxide Density (C4)
//   - Sulphur Dioxide Density (C5)
//   - PM2.5 Density (C6)
//   - PM10 Density (C7)
//   - VOC Density (C8)
//   - Carbon Monoxide Level (90)
//   - Carbon Dioxide Level (93)
//
// UUID: 0000008D-0000-1000-8000-0026BB765291
func AirQualitySensor(airQuality hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{airQuality}
	return characteristic.Service{
		Typ:            AirQualitySensor_Type,
		Characteristic: append(chars, optional...),
	}
}

const BatteryService_Type = "96"

// BatteryService represents a Battery Service service (96)
// Required characteristics:
//   - batteryLevel: Battery Level (68)
//   - chargingState: Charging State (8F)
//   - statusLowBattery: Status Low Battery (79)
//
// Optional characteristics:
//   - Name (23)
//
// UUID: 00000096-0000-1000-8000-0026BB765291
func BatteryService(batteryLevel hapip.Characteristic, chargingState hapip.Characteristic, statusLowBattery hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{batteryLevel, chargingState, statusLowBattery}
	return characteristic.Service{
		Typ:            BatteryService_Type,
		Characteristic: append(chars, optional...),
	}
}

const CameraRTPStreamManagement_Type = "110"

// CameraRTPStreamManagement represents a Camera RTP Stream Management service (110)
// Required characteristics:
//   - supportedVideoStreamConfiguration: Supported Video Stream Configuration (114)
//   - supportedAudioStreamConfiguration: Supported Audio Stream Configuration (115)
//   - supportedRTPConfiguration: Supported RTP Configuration (116)
//   - selectedRTPStreamConfiguration: Selected RTP Stream Configuration (117)
//   - streamingStatus: Streaming Status (120)
//   - setupEndpoints: Setup Endpoints (118)
//
// Optional characteristics:
//   - Name (23)
//
// UUID: 00000110-0000-1000-8000-0026BB765291
func CameraRTPStreamManagement(supportedVideoStreamConfiguration hapip.Characteristic, supportedAudioStreamConfiguration hapip.Characteristic, supportedRTPConfiguration hapip.Characteristic, selectedRTPStreamConfiguration hapip.Characteristic, streamingStatus hapip.Characteristic, setupEndpoints hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{supportedVideoStreamConfiguration, supportedAudioStreamConfiguration, supportedRTPConfiguration, selectedRTPStreamConfiguration, streamingStatus, setupEndpoints}
	return characteristic.Service{
		Typ:            CameraRTPStreamManagement_Type,
		Characteristic: append(chars, optional...),
	}
}

const CarbonDioxideSensor_Type = "97"

// CarbonDioxideSensor represents a Carbon Dioxide Sensor service (97)
// Required characteristics:
//   - carbonDioxideDetected: Carbon Dioxide Detected (92)
//
// Optional characteristics:
//   - Status Active (75)
//   - Status Fault (77)
//   - Status Low Battery (79)
//   - Status Tampered (7A)
//   - Carbon Dioxide Level (93)
//   - Carbon Dioxide Peak Level (94)
//   - Name (23)
//
// UUID: 00000097-0000-1000-8000-0026BB765291
func CarbonDioxideSensor(carbonDioxideDetected hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{carbonDioxideDetected}
	return characteristic.Service{
		Typ:            CarbonDioxideSensor_Type,
		Characteristic: append(chars, optional...),
	}
}

const CarbonMonoxideSensor_Type = "7F"

// CarbonMonoxideSensor represents a Carbon Monoxide Sensor service (7F)
// Required characteristics:
//   - carbonMonoxideDetected: Carbon Monoxide Detected (69)
//
// Optional characteristics:
//   - Status Active (75)
//   - Status Fault (77)
//   - Status Low Battery (79)
//   - Status Tampered (7A)
//   - Carbon Monoxide Level (90)
//   - Carbon Monoxide Peak Level (91)
//   - Name (23)
//
// UUID: 0000007F-0000-1000-8000-0026BB765291
func CarbonMonoxideSensor(carbonMonoxideDetected hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{carbonMonoxideDetected}
	return characteristic.Service{
		Typ:            CarbonMonoxideSensor_Type,
		Characteristic: append(chars, optional...),
	}
}

const ContactSensor_Type = "80"

// ContactSensor represents a Contact Sensor service (80)
// Required characteristics:
//   - contactSensorState: Contact Sensor State (6A)
//
// Optional characteristics:
//   - Status Active (75)
//   - Status Fault (77)
//   - Status Tampered (7A)
//   - Status Low Battery (79)
//   - Name (23)
//
// UUID: 00000080-0000-1000-8000-0026BB765291
func ContactSensor(contactSensorState hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{contactSensorState}
	return characteristic.Service{
		Typ:            ContactSensor_Type,
		Characteristic: append(chars, optional...),
	}
}

const Door_Type = "81"

// Door represents a Door service (81)
// Required characteristics:
//   - currentPosition: Current Position (6D)
//   - positionState: Position State (72)
//   - targetPosition: Target Position (7C)
//
// Optional characteristics:
//   - Hold Position (6F)
//   - Obstruction Detected (24)
//   - Name (23)
//
// UUID: 00000081-0000-1000-8000-0026BB765291
func Door(currentPosition hapip.Characteristic, positionState hapip.Characteristic, targetPosition hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{currentPosition, positionState, targetPosition}
	return characteristic.Service{
		Typ:            Door_Type,
		Characteristic: append(chars, optional...),
	}
}

const Doorbell_Type = "121"

// Doorbell represents a Doorbell service (121)
// Required characteristics:
//   - programmableSwitchEvent: Programmable Switch Event (73)
//
// Optional characteristics:
//   - Brightness (8)
//   - Volume (119)
//   - Name (23)
//
// UUID: 00000121-0000-1000-8000-0026BB765291
func Doorbell(programmableSwitchEvent hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{programmableSwitchEvent}
	return characteristic.Service{
		Typ:            Doorbell_Type,
		Characteristic: append(chars, optional...),
	}
}

const Fan_Type = "40"

// Fan represents a Fan service (40)
// Required characteristics:
//   - on: On (25)
//
// Optional characteristics:
//   - Rotation Direction (28)
//   - Rotation Speed (29)
//   - Name (23)
//
// UUID: 00000040-0000-1000-8000-0026BB765291
func Fan(on hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{on}
	return characteristic.Service{
		Typ:            Fan_Type,
		Characteristic: append(chars, optional...),
	}
}

const FanV2_Type = "B7"

// FanV2 represents a Fan v2 service (B7)
// Required characteristics:
//   - active: Active (B0)
//
// Optional characteristics:
//   - Current Fan State (AF)
//   - Target Fan State (BF)
//   - Lock Physical Controls (A7)
//   - Name (23)
//   - Rotation Direction (28)
//   - Rotation Speed (29)
//   - Swing Mode (B6)
//
// UUID: 000000B7-0000-1000-8000-0026BB765291
func FanV2(active hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{active}
	return characteristic.Service{
		Typ:            FanV2_Type,
		Characteristic: append(chars, optional...),
	}
}

const FilterMaintenance_Type = "BA"

// FilterMaintenance represents a Filter Maintenance service (BA)
// Required characteristics:
//   - filterChangeIndication: Filter Change Indication (AC)
//
// Optional characteristics:
//   - Filter Life Level (AB)
//   - Reset Filter Indication (AD)
//   - Name (23)
//
// UUID: 000000BA-0000-1000-8000-0026BB765291
func FilterMaintenance(filterChangeIndication hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{filterChangeIndication}
	return characteristic.Service{
		Typ:            FilterMaintenance_Type,
		Characteristic: append(chars, optional...),
	}
}

const Faucet_Type = "D7"

// Faucet represents a Faucet service (D7)
// Required characteristics:
//   - active: Active (B0)
//
// Optional characteristics:
//   - Name (23)
//   - Status Fault (77)
//
// UUID: 000000D7-0000-1000-8000-0026BB765291
func Faucet(active hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{active}
	return characteristic.Service{
		Typ:            Faucet_Type,
		Characteristic: append(chars, optional...),
	}
}

const GarageDoorOpener_Type = "41"

// GarageDoorOpener represents a Garage Door Opener service (41)
// Required characteristics:
//   - currentDoorState: Current Door State (E)
//   - targetDoorState: Target Door State (32)
//   - obstructionDetected: Obstruction Detected (24)
//
// Optional characteristics:
//   - Lock Current State (1D)
//   - Lock Target State (1E)
//   - Name (23)
//
// UUID: 00000041-0000-1000-8000-0026BB765291
func GarageDoorOpener(currentDoorState hapip.Characteristic, targetDoorState hapip.Characteristic, obstructionDetected hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{currentDoorState, targetDoorState, obstructionDetected}
	return characteristic.Service{
		Typ:            GarageDoorOpener_Type,
		Characteristic: append(chars, optional...),
	}
}

const HeaterCooler_Type = "BC"

// HeaterCooler represents a Heater Cooler service (BC)
// Required characteristics:
//   - active: Active (B0)
//   - currentHeaterCoolerState: Current Heater Cooler State (B1)
//   - targetHeaterCoolerState: Target Heater Cooler State (B2)
//   - currentTemperature: Current Temperature (11)
//
// Optional characteristics:
//   - Lock Physical Controls (A7)
//   - Name (23)
//   - Swing Mode (B6)
//   - Cooling Threshold Temperature (D)
//   - Heating Threshold Temperature (12)
//   - Temperature Display Units (36)
//   - Rotation Speed (29)
//
// UUID: 000000BC-0000-1000-8000-0026BB765291
func HeaterCooler(active hapip.Characteristic, currentHeaterCoolerState hapip.Characteristic, targetHeaterCoolerState hapip.Characteristic, currentTemperature hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{active, currentHeaterCoolerState, targetHeaterCoolerState, currentTemperature}
	return characteristic.Service{
		Typ:            HeaterCooler_Type,
		Characteristic: append(chars, optional...),
	}
}

const HumidifierDehumidifier_Type = "BD"

// HumidifierDehumidifier represents a Humidifier Dehumidifier service (BD)
// Required characteristics:
//   - currentRelativeHumidity: Current Relative Humidity (10)
//   - currentHumidifierDehumidifierState: Current Humidifier Dehumidifier State (B3)
//   - targetHumidifierDehumidifierState: Target Humidifier Dehumidifier State (B4)
//   - active: Active (B0)
//
// Optional characteristics:
//   - Lock Physical Controls (A7)
//   - Name (23)
//   - Swing Mode (B6)
//   - Water Level (B5)
//   - Relative Humidity Dehumidifier Threshold (C9)
//   - Relative Humidity Humidifier Threshold (CA)
//   - Rotation Speed (29)
//
// UUID: 000000BD-0000-1000-8000-0026BB765291
func HumidifierDehumidifier(currentRelativeHumidity hapip.Characteristic, currentHumidifierDehumidifierState hapip.Characteristic, targetHumidifierDehumidifierState hapip.Characteristic, active hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{currentRelativeHumidity, currentHumidifierDehumidifierState, targetHumidifierDehumidifierState, active}
	return characteristic.Service{
		Typ:            HumidifierDehumidifier_Type,
		Characteristic: append(chars, optional...),
	}
}

const HumiditySensor_Type = "82"

// HumiditySensor represents a Humidity Sensor service (82)
// Required characteristics:
//   - currentRelativeHumidity: Current Relative Humidity (10)
//
// Optional characteristics:
//   - Status Active (75)
//   - Status Fault (77)
//   - Status Tampered (7A)
//   - Status Low Battery (79)
//   - Name (23)
//
// UUID: 00000082-0000-1000-8000-0026BB765291
func HumiditySensor(currentRelativeHumidity hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{currentRelativeHumidity}
	return characteristic.Service{
		Typ:            HumiditySensor_Type,
		Characteristic: append(chars, optional...),
	}
}

const IrrigationSystem_Type = "CF"

// IrrigationSystem represents a Irrigation System service (CF)
// Required characteristics:
//   - active: Active (B0)
//   - programMode: Program Mode (D1)
//   - inUse: In Use (D2)
//
// Optional characteristics:
//   - Name (23)
//   - Remaining Duration (D4)
//   - Status Fault (77)
//
// UUID: 000000CF-0000-1000-8000-0026BB765291
func IrrigationSystem(active hapip.Characteristic, programMode hapip.Characteristic, inUse hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{active, programMode, inUse}
	return characteristic.Service{
		Typ:            IrrigationSystem_Type,
		Characteristic: append(chars, optional...),
	}
}

const LeakSensor_Type = "83"

// LeakSensor represents a Leak Sensor service (83)
// Required characteristics:
//   - leakDetected: Leak Detected (70)
//
// Optional characteristics:
//   - Status Active (75)
//   - Status Fault (77)
//   - Status Tampered (7A)
//   - Status Low Battery (79)
//   - Name (23)
//
// UUID: 00000083-0000-1000-8000-0026BB765291
func LeakSensor(leakDetected hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{leakDetected}
	return characteristic.Service{
		Typ:            LeakSensor_Type,
		Characteristic: append(chars, optional...),
	}
}

const LightSensor_Type = "84"

// LightSensor represents a Light Sensor service (84)
// Required characteristics:
//   - currentAmbientLightLevel: Current Ambient Light Level (6B)
//
// Optional characteristics:
//   - Name (23)
//   - Status Active (75)
//   - Status Fault (77)
//   - Status Tampered (7A)
//   - Status Low Battery (79)
//
// UUID: 00000084-0000-1000-8000-0026BB765291
func LightSensor(currentAmbientLightLevel hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{currentAmbientLightLevel}
	return characteristic.Service{
		Typ:            LightSensor_Type,
		Characteristic: append(chars, optional...),
	}
}

const Lightbulb_Type = "43"

// Lightbulb represents a Lightbulb service (43)
// Required characteristics:
//   - on: On (25)
//
// Optional characteristics:
//   - Brightness (8)
//   - Hue (13)
//   - Saturation (2F)
//   - Name (23)
//
// UUID: 00000043-0000-1000-8000-0026BB765291
func Lightbulb(on hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{on}
	return characteristic.Service{
		Typ:            Lightbulb_Type,
		Characteristic: append(chars, optional...),
	}
}

const LockManagement_Type = "44"

// LockManagement represents a Lock Management service (44)
// Required characteristics:
//   - lockControlPoint: Lock Control Point (19)
//   - version: Version (37)
//
// Optional characteristics:
//   - Logs (1F)
//   - Audio Feedback (5)
//   - Lock Management Auto Security Timeout (1A)
//   - Administrator Only Access (1)
//   - Lock Last Known Action (1C)
//   - Current Door State (E)
//   - Motion Detected (22)
//   - Name (23)
//
// UUID: 00000044-0000-1000-8000-0026BB765291
func LockManagement(lockControlPoint hapip.Characteristic, version hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{lockControlPoint, version}
	return characteristic.Service{
		Typ:            LockManagement_Type,
		Characteristic: append(chars, optional...),
	}
}

const LockMechanism_Type = "45"

// LockMechanism represents a Lock Mechanism service (45)
// Required characteristics:
//   - lockCurrentState: Lock Current State (1D)
//   - lockTargetState: Lock Target State (1E)
//
// Optional characteristics:
//   - Name (23)
//
// UUID: 00000045-0000-1000-8000-0026BB765291
func LockMechanism(lockCurrentState hapip.Characteristic, lockTargetState hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{lockCurrentState, lockTargetState}
	return characteristic.Service{
		Typ:            LockMechanism_Type,
		Characteristic: append(chars, optional...),
	}
}

const Microphone_Type = "112"

// Microphone represents a Microphone service (112)
// Required characteristics:
//   - volume: Volume (119)
//   - mute: Mute (11A)
//
// Optional characteristics:
//   - Name (23)
//
// UUID: 00000112-0000-1000-8000-0026BB765291
func Microphone(volume hapip.Characteristic, mute hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{volume, mute}
	return characteristic.Service{
		Typ:            Microphone_Type,
		Characteristic: append(chars, optional...),
	}
}

const MotionSensor_Type = "85"

// MotionSensor represents a Motion Sensor service (85)
// Required characteristics:
//   - motionDetected: Motion Detected (22)
//
// Optional characteristics:
//   - Status Active (75)
//   - Status Fault (77)
//   - Status Tampered (7A)
//   - Status Low Battery (79)
//   - Name (23)
//
// UUID: 00000085-0000-1000-8000-0026BB765291
func MotionSensor(motionDetected hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{motionDetected}
	return characteristic.Service{
		Typ:            MotionSensor_Type,
		Characteristic: append(chars, optional...),
	}
}

const OccupancySensor_Type = "86"

// OccupancySensor represents a Occupancy Sensor service (86)
// Required characteristics:
//   - occupancyDetected: Occupancy Detected (71)
//
// Optional characteristics:
//   - Name (23)
//   - Status Active (75)
//   - Status Fault (77)
//   - Status Tampered (7A)
//   - Status Low Battery (79)
//
// UUID: 00000086-0000-1000-8000-0026BB765291
func OccupancySensor(occupancyDetected hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{occupancyDetected}
	return characteristic.Service{
		Typ:            OccupancySensor_Type,
		Characteristic: append(chars, optional...),
	}
}

const Outlet_Type = "47"

// Outlet represents a Outlet service (47)
// Required characteristics:
//   - on: On (25)
//   - outletInUse: Outlet In Use (26)
//
// Optional characteristics:
//   - Name (23)
//
// UUID: 00000047-0000-1000-8000-0026BB765291
func Outlet(on hapip.Characteristic, outletInUse hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{on, outletInUse}
	return characteristic.Service{
		Typ:            Outlet_Type,
		Characteristic: append(chars, optional...),
	}
}

const SecuritySystem_Type = "7E"

// SecuritySystem represents a Security System service (7E)
// Required characteristics:
//   - securitySystemCurrentState: Security System Current State (66)
//   - securitySystemTargetState: Security System Target State (67)
//
// Optional characteristics:
//   - Status Fault (77)
//   - Status Tampered (7A)
//   - Security System Alarm Type (8E)
//   - Name (23)
//
// UUID: 0000007E-0000-1000-8000-0026BB765291
func SecuritySystem(securitySystemCurrentState hapip.Characteristic, securitySystemTargetState hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{securitySystemCurrentState, securitySystemTargetState}
	return characteristic.Service{
		Typ:            SecuritySystem_Type,
		Characteristic: append(chars, optional...),
	}
}

const ServiceLabel_Type = "CC"

// ServiceLabel represents a Service Label service (CC)
// Required characteristics:
//   - serviceLabelNamespace: Service Label Namespace (CD)
//
// Optional characteristics:
//   - Name (23)
//
// UUID: 000000CC-0000-1000-8000-0026BB765291
func ServiceLabel(serviceLabelNamespace hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{serviceLabelNamespace}
	return characteristic.Service{
		Typ:            ServiceLabel_Type,
		Characteristic: append(chars, optional...),
	}
}

const Slat_Type = "B9"

// Slat represents a Slat service (B9)
// Required characteristics:
//   - slatType: Slat Type (C0)
//   - currentSlatState: Current Slat State (AA)
//
// Optional characteristics:
//   - Name (23)
//   - Current Tilt Angle (C1)
//   - Target Tilt Angle (C2)
//   - Swing Mode (B6)
//
// UUID: 000000B9-0000-1000-8000-0026BB765291
func Slat(slatType hapip.Characteristic, currentSlatState hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{slatType, currentSlatState}
	return characteristic.Service{
		Typ:            Slat_Type,
		Characteristic: append(chars, optional...),
	}
}

const SmokeSensor_Type = "87"

// SmokeSensor represents a Smoke Sensor service (87)
// Required characteristics:
//   - smokeDetected: Smoke Detected (76)
//
// Optional characteristics:
//   - Status Active (75)
//   - Status Fault (77)
//   - Status Tampered (7A)
//   - Status Low Battery (79)
//   - Name (23)
//
// UUID: 00000087-0000-1000-8000-0026BB765291
func SmokeSensor(smokeDetected hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{smokeDetected}
	return characteristic.Service{
		Typ:            SmokeSensor_Type,
		Characteristic: append(chars, optional...),
	}
}

const Speaker_Type = "113"

// Speaker represents a Speaker service (113)
// Required characteristics:
//   - mute: Mute (11A)
//
// Optional characteristics:
//   - Name (23)
//   - Volume (119)
//
// UUID: 00000113-0000-1000-8000-0026BB765291
func Speaker(mute hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{mute}
	return characteristic.Service{
		Typ:            Speaker_Type,
		Characteristic: append(chars, optional...),
	}
}

const StatelessProgrammableSwitch_Type = "89"

// StatelessProgrammableSwitch represents a Stateless Programmable Switch service (89)
// Required characteristics:
//   - programmableSwitchEvent: Programmable Switch Event (73)
//
// Optional characteristics:
//   - Name (23)
//   - Service Label Index (CB)
//
// UUID: 00000089-0000-1000-8000-0026BB765291
func StatelessProgrammableSwitch(programmableSwitchEvent hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{programmableSwitchEvent}
	return characteristic.Service{
		Typ:            StatelessProgrammableSwitch_Type,
		Characteristic: append(chars, optional...),
	}
}

const Switch_Type = "49"

// Switch represents a Switch service (49)
// Required characteristics:
//   - on: On (25)
//
// Optional characteristics:
//   - Name (23)
//
// UUID: 00000049-0000-1000-8000-0026BB765291
func Switch(on hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{on}
	return characteristic.Service{
		Typ:            Switch_Type,
		Characteristic: append(chars, optional...),
	}
}

const TemperatureSensor_Type = "8A"

// TemperatureSensor represents a Temperature Sensor service (8A)
// Required characteristics:
//   - currentTemperature: Current Temperature (11)
//
// Optional characteristics:
//   - Status Active (75)
//   - Status Fault (77)
//   - Status Low Battery (79)
//   - Status Tampered (7A)
//   - Name (23)
//
// UUID: 0000008A-0000-1000-8000-0026BB765291
func TemperatureSensor(currentTemperature hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{currentTemperature}
	return characteristic.Service{
		Typ:            TemperatureSensor_Type,
		Characteristic: append(chars, optional...),
	}
}

const Thermostat_Type = "4A"

// Thermostat represents a Thermostat service (4A)
// Required characteristics:
//   - currentHeatingCoolingState: Current Heating Cooling State (F)
//   - targetHeatingCoolingState: Target Heating Cooling State (33)
//   - currentTemperature: Current Temperature (11)
//   - targetTemperature: Target Temperature (35)
//   - temperatureDisplayUnits: Temperature Display Units (36)
//
// Optional characteristics:
//   - Current Relative Humidity (10)
//   - Target Relative Humidity (34)
//   - Cooling Threshold Temperature (D)
//   - Heating Threshold Temperature (12)
//   - Name (23)
//
// UUID: 0000004A-0000-1000-8000-0026BB765291
func Thermostat(currentHeatingCoolingState hapip.Characteristic, targetHeatingCoolingState hapip.Characteristic, currentTemperature hapip.Characteristic, targetTemperature hapip.Characteristic, temperatureDisplayUnits hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{currentHeatingCoolingState, targetHeatingCoolingState, currentTemperature, targetTemperature, temperatureDisplayUnits}
	return characteristic.Service{
		Typ:            Thermostat_Type,
		Characteristic: append(chars, optional...),
	}
}

const Valve_Type = "D0"

// Valve represents a Valve service (D0)
// Required characteristics:
//   - active: Active (B0)
//   - inUse: In Use (D2)
//   - valveType: Valve Type (D5)
//
// Optional characteristics:
//   - Set Duration (D3)
//   - Remaining Duration (D4)
//   - Is Configured (D6)
//   - Service Label Index (CB)
//   - Status Fault (77)
//   - Name (23)
//
// UUID: 000000D0-0000-1000-8000-0026BB765291
func Valve(active hapip.Characteristic, inUse hapip.Characteristic, valveType hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{active, inUse, valveType}
	return characteristic.Service{
		Typ:            Valve_Type,
		Characteristic: append(chars, optional...),
	}
}

const Window_Type = "8B"

// Window represents a Window service (8B)
// Required characteristics:
//   - currentPosition: Current Position (6D)
//   - targetPosition: Target Position (7C)
//   - positionState: Position State (72)
//
// Optional characteristics:
//   - Hold Position (6F)
//   - Obstruction Detected (24)
//   - Name (23)
//
// UUID: 0000008B-0000-1000-8000-0026BB765291
func Window(currentPosition hapip.Characteristic, targetPosition hapip.Characteristic, positionState hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{currentPosition, targetPosition, positionState}
	return characteristic.Service{
		Typ:            Window_Type,
		Characteristic: append(chars, optional...),
	}
}

const WindowCovering_Type = "8C"

// WindowCovering represents a Window Covering service (8C)
// Required characteristics:
//   - currentPosition: Current Position (6D)
//   - targetPosition: Target Position (7C)
//   - positionState: Position State (72)
//
// Optional characteristics:
//   - Hold Position (6F)
//   - Target Horizontal Tilt Angle (7B)
//   - Target Vertical Tilt Angle (7D)
//   - Current Horizontal Tilt Angle (6C)
//   - Current Vertical Tilt Angle (6E)
//   - Obstruction Detected (24)
//   - Name (23)
//
// UUID: 0000008C-0000-1000-8000-0026BB765291
func WindowCovering(currentPosition hapip.Characteristic, targetPosition hapip.Characteristic, positionState hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{currentPosition, targetPosition, positionState}
	return characteristic.Service{
		Typ:            WindowCovering_Type,
		Characteristic: append(chars, optional...),
	}
}

const Television_Type = "D8"

// Television represents a Television service (D8)
// Required characteristics:
//   - active: Active (B0)
//   - activeIdentifier: Active Identifier (E7)
//   - configuredName: Configured Name (E3)
//   - sleepDiscoveryMode: Sleep Discovery Mode (E8)
//
// Optional characteristics:
//   - Brightness (8)
//   - Closed Captions (DD)
//   - Display Order (136)
//   - Current Media State (E0)
//   - Target Media State (137)
//   - Picture Mode (E2)
//   - Power Mode Selection (DF)
//   - Remote Key (E1)
//
// UUID: 000000D8-0000-1000-8000-0026BB765291
func Television(active hapip.Characteristic, activeIdentifier hapip.Characteristic, configuredName hapip.Characteristic, sleepDiscoveryMode hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{active, activeIdentifier, configuredName, sleepDiscoveryMode}
	return characteristic.Service{
		Typ:            Television_Type,
		Characteristic: append(chars, optional...),
	}
}

const InputSource_Type = "D9"

// InputSource represents a Input Source service (D9)
// Required characteristics:
//   - configuredName: Configured Name (E3)
//   - inputSourceType: Input Source Type (DB)
//   - isConfigured: Is Configured (D6)
//   - currentVisibilityState: Current Visibility State (135)
//
// Optional characteristics:
//   - Identifier (E6)
//   - Input Device Type (DC)
//   - Target Visibility State (134)
//   - Name (23)
//
// UUID: 000000D9-0000-1000-8000-0026BB765291
func InputSource(configuredName hapip.Characteristic, inputSourceType hapip.Characteristic, isConfigured hapip.Characteristic, currentVisibilityState hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{configuredName, inputSourceType, isConfigured, currentVisibilityState}
	return characteristic.Service{
		Typ:            InputSource_Type,
		Characteristic: append(chars, optional...),
	}
}

const CameraRecordingManagement_Type = "204"

// CameraRecordingManagement represents a Camera Recording Management service (204)
// Required characteristics:
//   - supportedCameraRecordingConfiguration: Supported Camera Recording Configuration (205)
//   - supportedVideoRecordingConfiguration: Supported Video Recording Configuration (206)
//   - supportedAudioRecordingConfiguration: Supported Audio Recording Configuration (207)
//   - selectedCameraRecordingConfiguration: Selected Camera Recording Configuration (209)
//
// UUID: 00000204-0000-1000-8000-0026BB765291
func CameraRecordingManagement(supportedCameraRecordingConfiguration hapip.Characteristic, supportedVideoRecordingConfiguration hapip.Characteristic, supportedAudioRecordingConfiguration hapip.Characteristic, selectedCameraRecordingConfiguration hapip.Characteristic, optional ...hapip.Characteristic) characteristic.Service {
	chars := []hapip.Characteristic{supportedCameraRecordingConfiguration, supportedVideoRecordingConfiguration, supportedAudioRecordingConfiguration, selectedCameraRecordingConfiguration}
	return characteristic.Service{
		Typ:            CameraRecordingManagement_Type,
		Characteristic: append(chars, optional...),
	}
}
